% Sample script to call sparse and non-negative emPCA routines.
%
% Copyright 2013 Christian Sigg (christian@sigg-iten.ch)
% See license file for details.
%
% This code is no longer actively maintained. See my 'nsprcomp' R package
% for a better documented and more feature complete implementation.

%% Constants

global PRM;
PRM.emPCA_L1.eps = 1e-4;    % iteration stopping criterion
PRM.emPCA_L1.optimize = 1;  % optimize weights for given sparsity pattern
PRM.emPCA_L1_NN.eps = 1e-4;    % iteration stopping criterion
PRM.emPCA_L1_NN.optimize = 1;  % optimize weights for given sparsity pattern

K = 100;

%% Load Data

L = load('sampledata');
X = zeromean(L.X);

% Loadings of first PC have all equal signs, project to orthogonal subspace
% to pose meaningful NN problem.
[xx, w] = PCA(X,1);
d = size(X,2);
X = ((eye(d) - w*w')*X')';

%% Run sparse emPCA

W_s = [];
for k=1:K
	W_s(:,end+1) = emPCA_L1(X,k);
end

%% Run non-negative sparse emPCA

W_nns = [];
for k=1:K
	W_nns(:,end+1) = emPCA_L1_NN(X,k);
end

%% Plot variance vs. cardinality

plot(var(X*W_s),'-ok'); hold all
plot(var(X*W_nns),'-sr'); hold off
xlabel('Cardinality');
ylabel('Variance');
legend('emPCA', 'emPCA (nn)');
